// JGameEx26.java

import ch.aplu.jgamegrid.*;

public class JGameEx26 extends GameGrid implements GGActorCollisionListener
{
  public JGameEx26()
  {
    super(600, 600, 1, false);
    setSimulationPeriod(10);
    Stick stick1 = new Stick();
    addActor(stick1, new Location(200, 200), 30);
    stick1.show(0);
    Stick stick2 = new Stick();
    addActor(stick2, new Location(400, 400), 30);
    stick2.show(1);
    stick1.addCollisionActor(stick2);
    stick1.addActorCollisionListener(this);
    playSound(this, GGSound.DUMMY);
    show();
    doRun();
  }

  public int collide(Actor actor1, Actor actor2)
  {
    actor1.setDirection(actor1.getDirection() + 180);
    actor2.setDirection(actor2.getDirection() + 180);
    playSound(this, GGSound.PING);
    return 10;
  }

  public static void main(String[] args)
  {
    new JGameEx26();
  }
}

// --------------------- class Stick ----------------------------------
class Stick extends Actor
{
  private final double step = 1;

  public Stick()
  {
    super(true, "sprites/stick.gif", 2 );  // Rotatable
  }

  public void act()
  {
    Location loc = getLocation();
    double dir = (getDirection() + step) % 360;

    if (loc.x < 50)
    {
      dir = 180 - dir;
      setLocation(new Location(55, loc.y));
    }
    if (loc.x > 550)
    {
      dir = 180 - dir;
      setLocation(new Location(545, loc.y));
    }
    if (loc.y < 50)
    {
      dir = 360 - dir;
      setLocation(new Location(loc.x, 55));
    }
    if (loc.y > 550)
    {
      dir = 360 - dir;
      setLocation(new Location(loc.x, 545));
    }
    setDirection(dir);
    move();
  }
}


